/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Iconv.xs. Do not edit this file, edit Iconv.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Iconv.xs"
/* $Id: Iconv.xs,v 1.9 2001/08/11 10:10:04 mxp Exp $ */
/* XSUB for Perl module Text::Iconv                  */
/* Copyright (c) 2000 Michael Piotrowski             */

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <iconv.h>

/*****************************************************************************/

static int raise_error = 0;

SV *do_conv(iconv_t iconv_handle, SV *string)
{
   char    *ibuf;         /* char* to the content of SV *string */
   char    *obuf;         /* temporary output buffer */
   size_t  inbytesleft;   /* no. of bytes left to convert; initially
			     this is the length of the input string,
			     and 0 when the conversion has finished */
   size_t  outbytesleft;  /* no. of bytes in the output buffer */
   size_t  l_obuf;        /* length of the output buffer */
   char    *icursor;      /* current position in the input buffer */
   /* The Single UNIX Specification (version 1 and version 2), as well
      as the HP-UX documentation from which the XPG iconv specs are
      derived, are unclear about the type of the second argument to
      iconv() (here called icursor): The manpages say const char **,
      while the header files say char **. */
   char    *ocursor;      /* current position in the output buffer */
   size_t  ret;           /* iconv() return value */
   SV      *perl_str;     /* Perl return string */

   /* Check if the input string is actually `defined'; otherwise
      simply return undef.  This is not considered an error. */

   if (! SvOK(string))
   {
      return(&PL_sv_undef);
   }
   
   perl_str = newSVpv("", 0);

   /* Get length of input string.  That's why we take an SV* instead
      of a char*: This way we can convert UCS-2 strings because we
      know their length. */

   inbytesleft = SvCUR(string);
   ibuf        = SvPV(string, inbytesleft);
   
   /* Calculate approximate amount of memory needed for the temporary
      output buffer and reserve the memory.  The idea is to choose it
      large enough from the beginning to reduce the number of copy
      operations when converting from a single-byte to a multibyte
      encoding. */
   
   if(inbytesleft <= MB_LEN_MAX)
   {
      outbytesleft = MB_LEN_MAX + 1;
   }
   else
   {
      outbytesleft = 2 * inbytesleft;
   }

   l_obuf = outbytesleft;
   obuf   = (char *) New(0, obuf, outbytesleft, char); /* Perl malloc */

   /**************************************************************************/

   icursor = ibuf;
   ocursor = obuf;

   /**************************************************************************/
   
   while(inbytesleft != 0)
   {
#ifdef __hpux
      /* Even in HP-UX 11.00, documentation and header files do not agree */
      ret = iconv(iconv_handle, &icursor, &inbytesleft,
		                &ocursor, &outbytesleft);
#else
      ret = iconv(iconv_handle, (const char **)&icursor, &inbytesleft,
		                &ocursor, &outbytesleft);
#endif

      if(ret == (size_t) -1)
      {
	 switch(errno)
	 {
	    case EILSEQ:
	       /* Stop conversion if input character encountered which
		  does not belong to the input char set */
	       if (raise_error)
		  croak("Character not from source char set: %s",
			strerror(errno));
	       Safefree(obuf);   
	       return(&PL_sv_undef);
	    case EINVAL:
	       /* Stop conversion if we encounter an incomplete
                  character or shift sequence */
	       if (raise_error)
		  croak("Incomplete character or shift sequence: %s",
			strerror(errno));
	       Safefree(obuf);   
	       return(&PL_sv_undef);
	    case E2BIG:
	       /* If the output buffer is not large enough, copy the
                  converted bytes to the return string, reset the
                  output buffer and continue */
	       sv_catpvn(perl_str, obuf, l_obuf - outbytesleft);
	       ocursor = obuf;
	       outbytesleft = l_obuf;
	       break;
	    default:
	       if (raise_error)
		  croak("iconv error: %s", strerror(errno));
	       Safefree(obuf);   
	       return(&PL_sv_undef);
	 }
      }
   }

   /* Copy the converted bytes to the return string, and free the
      output buffer */
   
   sv_catpvn(perl_str, obuf, l_obuf - outbytesleft);
   Safefree(obuf); /* Perl malloc */

   return perl_str;
}

typedef iconv_t Text__Iconv;

/*****************************************************************************/
/* Perl interface                                                            */

#line 154 "Iconv.c"
XS(XS_Text__Iconv_raise_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Text__Iconv_raise_error)
{
    dXSARGS;
    {
	int	RETVAL;
	dXSTARG;
#line 151 "Iconv.xs"
      if (items > 0 && SvIOK(ST(0))) /* if called as function */
         raise_error = SvIV(ST(0));
      if (items > 1 && SvIOK(ST(1))) /* if called as class method */
         raise_error = SvIV(ST(1));
      RETVAL = raise_error;
#line 168 "Iconv.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Text__Iconv_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Text__Iconv_new)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Text::Iconv::new(self, fromcode, tocode)");
    {
	char *	fromcode = (char *)SvPV_nolen(ST(1));
	char *	tocode = (char *)SvPV_nolen(ST(2));
	Text__Iconv	RETVAL;
#line 164 "Iconv.xs"
   if((RETVAL = iconv_open(tocode, fromcode)) == (iconv_t)-1)
   {
      switch(errno)
      {
	 case ENOMEM:
	    croak("Insufficient memory to initialize conversion: %s", 
		  strerror(errno));
	 case EINVAL:
	    croak("Unsupported conversion: %s", strerror(errno));
	 default:
	    croak("Couldn't initialize conversion: %s", strerror(errno));
      }
   }
#line 198 "Iconv.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Text::Iconv", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Text__Iconv_convert); /* prototype to pass -Wmissing-prototypes */
XS(XS_Text__Iconv_convert)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Text::Iconv::convert(self, string)");
    {
	Text__Iconv	self;
	SV *	string = ST(1);
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Text::Iconv")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Text::Iconv");
#line 185 "Iconv.xs"
      RETVAL = do_conv(self, string);
#line 224 "Iconv.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Text__Iconv_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Text__Iconv_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Text::Iconv::DESTROY(self)");
    {
	Text__Iconv	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Text__Iconv,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 193 "Iconv.xs"
      /* printf("Now in Text::Iconv::DESTROY\n"); */
      (void) iconv_close(self);
#line 249 "Iconv.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Text__Iconv); /* prototype to pass -Wmissing-prototypes */
XS(boot_Text__Iconv)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Text::Iconv::raise_error", XS_Text__Iconv_raise_error, file, ";@");
        newXSproto("Text::Iconv::new", XS_Text__Iconv_new, file, "$$$");
        newXSproto("Text::Iconv::convert", XS_Text__Iconv_convert, file, "$$");
        newXSproto("Text::Iconv::DESTROY", XS_Text__Iconv_DESTROY, file, "$");
    XSRETURN_YES;
}

